//----------------------------------------------------------------------------
// C main line
//----------------------------------------------------------------------------

#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules

extern BYTE SOF_Flag;
BYTE StringIndex, TypingDelay;
BYTE Report[8];
BYTE const FixedString[] = {"BABEL "};
BYTE const HidUsageTable[] = {
// ASCII to HID_Usage lookup table, this table does not allow for shift
	0x2c,0x1e,0x34,0x20,0x21,0x22,0x24,0x34,0x26,0x27,0x25,0x2e,0x36,0x2d,0x37,0x38,
	0x27,0x1e,0x1f,0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x33,0x33,0x36,0x2e,0x37,0x38,
	0x1f,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,0x10,0x11,0x12,
	0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x2f,0x31,0x30,0x23,0x2d,
	0x34,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,0x10,0x11,0x12,
	0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x2f,0x31,0x30,0x35,0
};
	
BYTE HidUsage(BYTE ASCII)
{
// Convert the ASCII character into a HID usage
// This routine implements printable characters but not Shift
	if (ASCII == 0x0a) return 0x28;		// CR
	if ((ASCII > 0x7F) | (ASCII < 0x20)) return 0;
	return HidUsageTable[ASCII - 0x20];
}

BYTE Typing (void) {
// Called every 1 msec, if not typing then return false
	if (StringIndex == 6) return FALSE;
// Else send the next character if ready
	if (TypingDelay++ > 20) {
		TypingDelay = 0;
		Report[2] = HidUsage(FixedString[StringIndex++]);
		USBFS_1_LoadInEP(2, &Report[0], 8, USB_TOGGLE);
	}
	return TRUE;
}


void main()
{
	M8C_EnableGInt;
	// Connect to the host
	USBFS_1_Start(0,USB_5V_OPERATION);
	
	// Wait to be enumerated
	while (!USBFS_1_bGetConfiguration());

	USBFS_1_INT_REG |= USBFS_1_INT_SOF_MASK;
	StringIndex = 0;
	
	while(1) {
		if (SOF_Flag) {
			SOF_Flag = 0;
			if (!Typing()) {
				/* - typing restart */
				StringIndex = 0;
			}
		}
	}
	
}
